import Utils._

object RandomReachability {
  def reachabilityChallenge(
    stateVars: Seq[StateIdentifier],
    auxiliaryVars: Seq[AuxiliaryIdentifier],
    inputVars: Seq[InputIdentifier],
  ): Unit = {
    val ts = TransitionSystem.random(stateVars, auxiliaryVars, inputVars)
    val from = randomMap(stateVars)
    val to = randomMap(stateVars)
    println(ts)
    ts.dump("ts")
    println("\n")
    println("Checking Reachability from:\n")
    println(mapToString(from))
    println("\nChecking Reachability to:\n")
    println(mapToString(to))
    println("\n")
    ts.checkReachabilityAtMost(from, to, 5) match {
      case None => println("Not reachable")
      case Some((sSeq, aSeq)) =>
        ts.dump("ts-path", Some((sSeq.zip(aSeq), sSeq.last)))
        println("Reachable (see path in ts-path.png)")
    }
  }
}
